Name: ovirt-engine-ui-extensions
Summary: oVirt UI Extensions
Version: 1.2.6
Release: 2
License: ASL 2.0
URL: http://www.ovirt.org/
Source: ovirt-engine-ui-extensions-1.2.6.tar.gz

BuildArch: noarch

# nodejs-modules embeds yarn and requires nodejs
BuildRequires: ovirt-engine-nodejs-modules >= 2.0.44-1

Requires: ovirt-engine-webadmin-portal >= 4.3
Requires: ovirt-ansible-collection >= 1.2.0

Obsoletes: ovirt-engine-dashboard < 1.3
Provides: ovirt-engine-dashboard = 1.3

%description
UI plugin that provides various extensions to oVirt administration UI.

Extensions include:
  - dashboard
  - VM migrate dialog
  - VM export dialog
  - VM manage GPU dialog
  - Cluster upgrade wizard

%prep

# Unpack the source:
%setup -q -n %{name}-%{version}

# Set up Node.js environment with dependencies linked to ./node_modules:
source %{_datadir}/ovirt-engine-nodejs-modules/setup-env.sh

# Change hardcoded deafult hash algorithm from legacy md4 to sha512
sed -i 's/md4/sha512/g' node_modules/webpack/lib/*.js
sed -i 's/md4/sha512/g' node_modules/webpack/lib/optimize/*.js
sed -i 's/md4/sha512/g' node_modules/copy-webpack-plugin/dist/*.js
sed -i 's/md4/sha512/g' node_modules/terser-webpack-plugin/dist/*.js
sed -i 's/md4/sha512/g' node_modules/babel-loader/lib/*.js

# Build the application:
yarn build

%install

# Install the files:
mkdir -p %{buildroot}%{_datadir}/%{name}
cp -r dist/* %{buildroot}%{_datadir}/%{name}
cp -r ansible-playbooks %{buildroot}%{_datadir}/%{name}

# Ensure that Engine ui-plugins directory exists:
mkdir -p %{buildroot}%{_datadir}/ovirt-engine/ui-plugins

# Link plugin resources to Engine ui-plugins directory:
ln -s "%{_datadir}/%{name}/ui-extensions.json" "%{buildroot}%{_datadir}/ovirt-engine/ui-plugins"
ln -s "%{_datadir}/%{name}/ui-extensions-resources" "%{buildroot}%{_datadir}/ovirt-engine/ui-plugins"

# Ensure the Engine playbooks directory exists:
mkdir -p %{buildroot}%{_datadir}/ovirt-engine/ansible-runner-service-project/project

# Link plugin playbooks to Engine playbooks directory:
ln -s "%{_datadir}/%{name}/ansible-playbooks/ovirt-cluster-upgrade.yml" "%{buildroot}%{_datadir}/ovirt-engine/ansible-runner-service-project/project"

%files
%{_datadir}/%{name}
%{_datadir}/ovirt-engine/ui-plugins/ui-extensions.json
%{_datadir}/ovirt-engine/ui-plugins/ui-extensions-resources
%{_datadir}/ovirt-engine/ansible-runner-service-project/project/ovirt-cluster-upgrade.yml
%doc README.adoc
%license LICENSE

%changelog
* Fri Mar 3 2023 yanjianqing<yanjianqing@kylinos.cn> -1.2.6-2
- Change hardcoded deafult hash algorithm from legacy md4 to sha512

* Tue Jul 6 2021 kymayl<mayilin@kylinos.cn> - 1.2.6-1
- upgrade package

* Thu Mar 05 2020 huihui.fu <huihui.fu@cs2c.com.cn> - 1.0.10-1
- Package initialization
